#ifndef _RAR_FILE_
#define _RAR_FILE_

#include "int64.hpp"
#include "rartypes.hpp"

typedef SceUID FileHandle;
#define BAD_HANDLE 0

class RAROptions;

enum FILE_HANDLETYPE {FILE_HANDLENORMAL,FILE_HANDLESTD,FILE_HANDLEERR};

enum FILE_ERRORTYPE {FILE_SUCCESS,FILE_NOTFOUND,FILE_READERROR};

struct FileStat
{
  uint FileAttr;
  uint FileTime;
  Int64 FileSize;
  bool IsDir;
};


class File
{
  private:
    void AddFileToList(FileHandle hFile);
    int DirectRead(void *Data,int Size);
    bool RawSeek(Int64 Offset,int Method);

    FileHandle hFile;
    bool SkipClose;
    Int64 pos; /*for PSP*/
  protected:
    bool OpenShared;
  public:
    char FileName[NM];
    wchar FileNameW[NM];

    uint CloseCount;
  public:
    File();
    virtual ~File();
    void operator = (File &SrcFile);
    bool Open(const char *Name,const wchar *NameW=NULL,bool OpenShared=false,bool Update=false);
    bool Close();
    int Read(void *Data,int Size);
    void Seek(Int64 Offset,int Method);
    Int64 Tell();
    byte GetByte();
    bool IsOpened() {return ((hFile != BAD_HANDLE) ? 1 : 0);}
    Int64 FileLength();
    char *GetName() {return(FileName);}
};

#endif
